hdu 5412 CRB and Queries

题目连接

http://acm.hdu.edu.cn/showproblem.php?pid=5412

CRB and Queries

Description

There are $N$ boys in CodeLand.
Boy i has his coding skill $A_{i}$.
CRB wants to know who has the suitable coding skill.
So you should treat the following two types of queries.
Query 1: 1 $l\ v$
The coding skill of Boy l has changed to $v$.
Query 2: 2 l $r\ k$
This is a report query which asks the $k-th$ smallest value of coding skill between Boy $l$ and Boy $r$(both inclusive).

Input

There are multiple test cases.
The first line contains a single integer $N$.
Next line contains $N$ space separated integers $A_{1}, A_{2}, …, A_{N}$, where $A_{i}$ denotes initial coding skill of Boy $i$.
Next line contains a single integer $Q$ representing the number of queries.
Next $Q$ lines contain queries which can be any of the two types.
$1 \leq N, Q \leq 10^{5} $
$1 \leq A_{i}, v \leq 10^{9}$
$1 \leq l \leq r \leq N$
$1 \leq k \leq r\ -\ l + 1$

Output

For each query of type 2, output a single integer corresponding to the answer in a single line.

Sample Input

5
1 2 3 4 5
3
2 2 4 2
1 3 6
2 2 4 2

Sample Output

3
4

树套树裸题。。

#include<algorithm>
#include<iostream>
#include<cstdlib>
#include<cstring>
#include<cstdio>
#include<vector>
#include<map>
using std::map;
using std::min;
using std::find;
using std::pair;
using std::vector;
using std::multimap;
#define pb(e) push_back(e)
#define sz(c) (int)(c).size()
#define mp(a, b) make_pair(a, b)
#define all(c) (c).begin(), (c).end()
#define iter(c) __typeof((c).begin())
#define cls(arr, val) memset(arr, val, sizeof(arr))
#define cpresent(c, e) (find(all(c), (e)) != (c).end())
#define rep(i, n) for(int i = 0; i < (int)n; i++)
#define tr(c, i) for(iter(c) i = (c).begin(); i != (c).end(); ++i)
#define lc root<<1
#define rc root<<1|1
const int N = 100010;
const int INF = 0x3f3f3f3f;
struct Node {
    int v, s, c;
    Node *ch[2];
    inline void push_up() {
        s = ch[0]->s + ch[1]->s + c;
    }
    inline void setc(int _v, int _s, Node *p) {
        v = _v, s = c = _s, ch[0] = ch[1] = p;
    }
    inline int cmp(int x) const {
        if (x == v) return -1;
        return x > v;
    }
};
int sum, arr[N];
struct SBT {
    int top;
    Node *null, *tail, *pool[N], stack[N << 5], *ptr[N << 2];
    inline void init(int n) {
        top = 0;
        tail = &stack[0];
        null = tail++;
        null->setc(0, 0, NULL);
        for (int i = 1; i <= n; i++) scanf("%d", &arr[i]);
        seg_built(1, 1, n);
    }
    inline Node *newNode(int v) {
        Node *p = !top ? tail++ : pool[--top];
        p->setc(v, 1, null);
        return p;
    }
    inline void rotate(Node *&x, int d) {
        Node *k = x->ch[!d]; x->ch[!d] = k->ch[d]; k->ch[d] = x;
        k->s = x->s; x->push_up(); x = k;
    }
    inline void Maintain(Node *&x, int d) {
        if (!x->ch[d]->s) return;
        if (x->ch[d]->ch[d]->s > x->ch[!d]->s) rotate(x, !d);
        else if (x->ch[d]->ch[!d]->s > x->ch[!d]->s) rotate(x->ch[d], d), rotate(x, !d);
        else  return;
        Maintain(x, 0), Maintain(x, 1);
    }
    inline void insert(Node* &x, int key) {
        if (!x->s) { x = newNode(key); return; }
        int d = x->cmp(key);
        x->s++;
        if (-1 == d) { x->c++; return; }
        insert(x->ch[d], key);
        x->push_up();
        Maintain(x, d);
    }
    inline void erase(Node* &x, int key){
    if (!x->s) return;
    int d = x->cmp(key);
    x->s--;
    if (-1 == d) {
        if (x->c > 1) {
            x->c--;
        } else if (!x->ch[0]->s || !x->ch[1]->s) {
            pool[top++] = x;
            x = x->ch[0]->s ? x->ch[0] : x->ch[1];
        } else {
            Node *ret = x->ch[1];
            for (; ret->ch[0]->s; ret = ret->ch[0]);
            erase(x->ch[1], x->v = ret->v);
        }
    } else {
        erase(x->ch[d], key);
    }
    if (x->s) x->push_up();
}
    inline int sbt_rank(Node *x, int key) {
        int t, cur = 0;
        for (; x->s;) {
            t = x->ch[0]->s;
            if (key < x->v) x = x->ch[0];
            else if (key >= x->v) cur += x->c + t, x = x->ch[1];
        }
        return cur;
    }
    inline void seg_built(int root, int l, int r) {
        ptr[root] = null;
        for (int i = l; i <= r; i++) insert(ptr[root], arr[i]);
        if (l == r) return;
        int mid = (l + r) >> 1;
        seg_built(lc, l, mid);
        seg_built(rc, mid + 1, r);
    }
    inline void seg_query(int root, int l, int r, int x, int y, int val) {
        if (x > r || y < l) return;
        if (x <= l && y >= r) {
            sum += sbt_rank(ptr[root], val);
            return;
        }
        int mid = (l + r) >> 1;
        seg_query(lc, l, mid, x, y, val);
        seg_query(rc, mid + 1, r, x, y, val);
    }
    inline void seg_modify(int root, int l, int r, int pos, int val) {
        if (pos > r || pos < l) return;
        erase(ptr[root], arr[pos]);
        insert(ptr[root], val);
        if (l == r) return;
        int mid = (l + r) >> 1;
        seg_modify(lc, l, mid, pos, val);
        seg_modify(rc, mid + 1, r, pos, val);
    }
    inline void kth(int n, int a, int b, int k) {
        int l = 0, r = INF;
        while (l < r) {
            sum = 0;
            int mid = (l + r) >> 1;
            seg_query(1, 1, n, a, b, mid);
            if (sum < k) l = mid + 1;
            else r = mid;
        }
        printf("%d\n", l);
    }
    inline void solve(int n) {
        init(n);
        int m, a, b, c, k;
        scanf("%d", &m);
        while (m--) {
            scanf("%d", &a);
            if (2 == a) {
                scanf("%d %d %d", &b, &c, &k);
                kth(n, b, c, k);
            } else {
                scanf("%d %d", &b, &c);
                seg_modify(1, 1, n, b, c);
                arr[b] = c;
            }
        }
    }
}go;
int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w+", stdout);
#endif
    int n;
    while (~scanf("%d", &n)) {
        go.solve(n);
    }
    return 0;
}
时间: 2024-10-05 16:16:43

hdu 5412 CRB and Queries的相关文章

hdu 5412 CRB and Queries(线段树套笛卡尔树 - 动态区间第k大)

题目链接:hdu 5412 CRB and Queries 首先对所有出现过的值排序,建立线段树,每个线段树的节点是一棵笛卡尔树,笛卡尔树记录区间下标值. #include <cstdio> #include <cstring> #include <cstdlib> #include <algorithm> using namespace std; #define lson(x) (x<<1) #define rson(x) ((x<<

HDU 5412——CRB and Queries——————【线段树套Treap(并没有AC)】

CRB and Queries Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 1602    Accepted Submission(s): 409 Problem Description There are N boys in CodeLand.Boy i has his coding skill Ai.CRB wants to

HDU 5412 CRB and Queries(区间第K大 树套数 按值建树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5412 Problem Description There are N boys in CodeLand. Boy i has his coding skill Ai. CRB wants to know who has the suitable coding skill. So you should treat the following two types of queries. Query 1:

HDU 5412 CRB and Queries (整体二分)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5412 题目大意:对一个数组A[N](N<= 10^5)进行两种操作: 1 l v:将第A[l]的值修改成v 2 l r k:求l~r区间的第k小值 操作总数为10^5. 2015年多校第十场的题目,当时乱套主席树什么的模板,发现并不能过,赛后学习了一种叫做整体二分的方法,感觉很是厉害. 整体二分是二分答案.大致方法如下: 1.先把所有对数组的操作保存起来,包括赋值. 2.从0~inf二分一个数值,并

【区间k大】HDU 54512 CRB and Queries

通道 题意:区间k大,单点修改 思路:裸,复杂度n(lgn)^2 代码: #include <cstdio> #include <cstring> #include <cstdlib> #include <iostream> #include <algorithm> using namespace std; const int N = 60010 * 5; const int M = 100100 * 4; #define INF 1000000

HDU 3726 Graph and Queries treap树

题目来源:HDU 3726 Graph and Queries 题意:见白书 思路:刚学treap 參考白皮书 #include <cstdio> #include <cstring> #include <cstdlib> using namespace std; struct Node { Node *ch[2]; int r; int v; int s; Node(int v): v(v) { ch[0] = ch[1] = NULL; r = rand(); s

hdu 3726 Graph and Queries(splay查询第k大,启发式合并,删除操作)

题目链接:hdu 3726 Graph and Queries 题意: 最开始给你n个点,每个点最开始有一个权值,并且都是独立的,现在给你m条边,表示对应的两个点是连接的. 现在有三种操作: Q x k,表示询问与x这个点联通的所有点中第k大的权值. D x,表示删除第x条边. C x y,表示改变x点的权值为y. 题解: 如果正着来做肯定比较麻烦,不好维护. 一看输出,可以离线处理,那么我们就倒着搞. 把所有的询问和边,点的变化全部存起来,然后用splay来维护. 每次删除就是倒着的合并,合并

多校10 1007 CRB and Queries

CRB and Queries Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 3233    Accepted Submission(s): 148 Problem Description There are N boys in CodeLand.Boy i has his coding skill Ai.CRB wants to

Hdu 5416 CRB and Tree (bfs)

题目链接: Hdu 5416 CRB and Tree 题目描述: 给一棵树有n个节点,树上的每条边都有一个权值.f(u,v)代表从u到v路径上所有边权的异或值,问满足f(u,v)==m的(u, v)有多少中情况(u, v有可能相同)? 解题思路: 由于xor的特殊性质.x^x=0,对于求f(u, v) == f(u, 1) ^ f(1, u). 又因为x^y == z可以推出x^z == y,对于f(u, 1) ^ f(1, v) == m可以转化为m ^ f(1, v) == f(u, 1)